#pragma once

#include "BaseWindow.h"
#include "ScriptletContainerFactory.h"

/**
* @class CBaseFrameWindow
* CBaseWindow  OnFinalMessage ׻ delete thisǴ 
* FrameWindow Ŭ̴.
*/
class CNotifyFrameWindow : public CBaseWindow
{
public:
	static int sm_ComponentCreatorID2;

public:
	CNotifyFrameWindow();
	virtual ~CNotifyFrameWindow()
	{
	}

	void SetMessageHwnd(HWND hWnd)
	{
		m_hMessageWnd = hWnd;
	}

	void AutoDeleteDataContext(BOOL bDelete=TRUE)
	{
		m_bAutoDelete = bDelete;
	}

protected:
	BEGIN_MSG_MAP(CNotifyFrameWindow)
		MESSAGE_HANDLER(WM_MOUSEMOVE, CNotifyFrameWindow::OnMouseMove)
		MESSAGE_HANDLER(WM_MOUSELEAVE, CNotifyFrameWindow::OnMouseLeave)
		CHAIN_MSG_MAP(CBaseWindow)
	END_MSG_MAP()
	HWND		m_hMessageWnd;
	BOOL		m_bAutoDelete;
protected:
	DECLARE_MESSAGE_HANDLER(OnMouseMove);
	DECLARE_MESSAGE_HANDLER(OnMouseLeave);

	void OnFinalMessage(HWND hWnd)
	{
		SimpleMapDataContext *context = dynamic_cast< SimpleMapDataContext* >(m_dataContext);
		BOOL bAutoDelete = m_bAutoDelete;

		delete this;
		//Must set position after delete this;
		if( bAutoDelete && context )
		{
			delete context;
		}
	}

};